#include "CharScene.h"
#include "GameScene.h"
#include "Character.h"

using namespace cocos2d;
using namespace CocosDenshion;

bool CharScene::init() {
    if (!CCLayerColor::initWithColor(ccc4f(0,255,255,255)))
        return false;
        
	setIsTouchEnabled( true );
    
	CCSize screenSize = CCDirector::sharedDirector()->getWinSize();
    
	CCLabelTTF *label;
    label = CCLabelTTF::labelWithString("[back]", "Futura-CondensedExtraBold", 32);
    label->setColor( ccc3(200,0,200) );
    
    CCMenuItem *button = CCMenuItemLabel::itemWithLabel(label, this, menu_selector(CharScene::onBack));
    
    CCMenu *menu = CCMenu::menuWithItem(button);
    
    menu->setPosition(50, screenSize.height-25);
    
    addChild(menu);
    
    
    Character* stats = Character::sharedInstance();

    char str[100];
    int py = screenSize.height-144;
    
    sprintf(str, "statistics:");
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96-12, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    sprintf(str, "level: %d", stats->level);
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    sprintf(str, "pennies: %d", stats->cash);
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    sprintf(str, "experience: %d", stats->experience);
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    sprintf(str, "wins: %d", stats->wins);
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    sprintf(str, "losses: %d", stats->losses);
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    sprintf(str, "flees: %d", stats->flees);
    label = CCLabelTTF::labelWithString(str, "Futura-CondensedExtraBold", 48);
    label->cocos2d::CCNode::setPosition(96, py);
    label->setAnchorPoint( ccp(0.0f, 0.5f) );
    py -= 50;
    addChild(label);
    
    
    // and your oponents avatar
    CCSprite* bunny = CCSprite::spriteWithSpriteFrameName("bunny1");
    bunny->setAnchorPoint(CCPoint(1.0f, 0.0f));
    bunny->setScale(8.0f);
    bunny->setFlipX(true);
    bunny->setPosition( CCPoint(screenSize.width-75, screenSize.height*0.5) );
    addChild(bunny);
    

    bunny->runAction(CCRepeat::actionWithAction(CCSequence::actions(CCMoveBy::actionWithDuration(2.0, ccp(0,-25)),
                                                   CCScaleTo::actionWithDuration(4.0f, 7.0),
                                                   CCMoveBy::actionWithDuration(2.0, ccp(0,25)),
                                                                    CCScaleTo::actionWithDuration(4.0f, 8.0), NULL), -1));
    
    
    return true;
}

CCScene* CharScene::scene() {
    CCScene *scene = CCScene::node();
    CCLayer* layer = CharScene::node();
    scene->addChild(layer);
    return scene;
}


void CharScene::onBack() {
    CCTransitionScene* transition = CCTransitionSlideInL::transitionWithDuration(1.0, GameScene::scene());
    CCDirector::sharedDirector()->replaceScene(transition);
}

void CharScene::draw() {
    CCLayerColor::draw();
}


void CharScene::ccTouchesEnded(CCSet* touches, CCEvent* event) {
}

