#pragma once

#include "cocos2d.h"
#include "GLESRender.h"
#include "SimpleAudioEngine.h"
#include "FightScene.h"

using namespace cocos2d;

class GameScene : public CCLayer {
public:
    static CCScene* scene();
    static CCScene* scene(FightData data);
    virtual bool init();
    LAYER_NODE_FUNC(GameScene);
    
    virtual void ccTouchesEnded(CCSet* touches, CCEvent* event);

//    virtual void visit();
private:
    void onChar();
    void onMenu();
    void centerViewport(CCPoint p);
    
    CCPoint tileCoordForPosition(CCPoint p);
    int buildingAtPosition(CCPoint p);
    int levelAtPosition(CCPoint p);
            
    void battleEnded(FightData data);
    void startBattle(int type, int level, CCPoint pos);
    void moveComplete();
    
    CCTMXTiledMap *mMap;
    CCTMXLayer *mBackground;
    CCTMXLayer *mForeground;
    CCTMXLayer *mFights;    
    CCTMXObjectGroup* mObjects;
    CCSprite *mPlayer;
    
    bool mIsWalking;
    CCPoint mWalkTo;
};

