#include "InitialScene.h"
#include "GameScene.h"

using namespace cocos2d;
using namespace CocosDenshion;

bool InitialScene::init() {
    if (!CCLayerColor::initWithColor(ccc4f(0,255,255,255)))
        return false;
    
	setIsTouchEnabled( true );
    
	CCSize screenSize = CCDirector::sharedDirector()->getWinSize();
    
    //	CCLabelTTF *label = CCLabelTTF::labelWithString("tap to begin", "Futura-CondensedExtraBold", 32);
    //	addChild(label, 0);
    //	
    //	label->setPosition( CCPointMake( screenSize.width/2, 25) );

    CCSpriteFrameCache::sharedSpriteFrameCache()->addSpriteFramesWithFile("sprites.plist");
    CCSpriteBatchNode *spriteSheet = CCSpriteBatchNode::batchNodeWithFile("sprites.pvr.gz");
    spriteSheet->getTexture()->setAliasTexParameters(); // pixelate instead of blur
    addChild(spriteSheet);
    
    CCSprite* bground = CCSprite::spriteWithSpriteFrameName("title");
    bground->setScale(4.0f);
    bground->setPosition( CCPoint(screenSize.width*0.5f, screenSize.height*0.5f) );
    addChild(bground);
    
	CCLabelTTF *label = CCLabelTTF::labelWithString("[new game]", "Futura-CondensedExtraBold", 32);
    label->setColor( ccc3(200,0,200) );

    label->runAction(CCBlink::actionWithDuration(60.0f, 80.0f));
    CCMenuItem *button = CCMenuItemLabel::itemWithLabel(label, this, menu_selector(InitialScene::onSwitch));
    
    CCMenu *menu = CCMenu::menuWithItem(button);
    
    
    menu->setPosition(screenSize.width * 0.5f, screenSize.height * 0.05f);
  
    addChild(menu);
    
    return true;
}


void InitialScene::onSwitch() {
    CCTransitionScene* transition = CCTransitionSlideInB::transitionWithDuration(1.0, GameScene::scene());
    CCDirector::sharedDirector()->replaceScene(transition);
}

void InitialScene::ccTouchesEnded(CCSet* touches, CCEvent* event) {
}

CCScene* InitialScene::scene() {
    CCScene *scene = CCScene::node();
    CCLayer* layer = InitialScene::node();
    scene->addChild(layer);
    return scene;
}
