/////////
// iOS template / framework
// Copyright 2011 Jacob Schwartz
// kevlarx@gmail.com
/////////
#ifndef _RANDOM_H_INCLUDED
#define _RANDOM_H_INCLUDED


/* Period parameters */  
#define RANDOM_N 624

// Mersenne twister pseudo-random number generator
class Random {
public:
    Random(uint32_t s=0);
    virtual ~Random();
    
    // if you plan on reproducing this sequence again, don't forget to save the seed (the state is ~2.5k, so this is preferable!)
    void seed(uint32_t s);
    
    // get number in [0,0xffffffff] range
    uint32_t rand();
    
    // get number in [low, high) range
    int32_t randRange(int32_t low, int32_t high);
    
    // get a number in [0, high) range
    int32_t randInt(int32_t high);
    
    // get number in [0,1) range (1 is not included)
    float randFloat();
    
private:
    Random(const Random& other);
    Random& operator=(const Random& other);
    
    unsigned long m_mt[RANDOM_N];
    int m_mti;
};

#endif // #ifndef _RANDOM_H_INCLUDED
